Index: trunk/src/org/expeditee/encryption/items/surrogates/EncryptionDetail.java
===================================================================
--- trunk/src/org/expeditee/encryption/items/surrogates/EncryptionDetail.java	(revision 1414)
+++ trunk/src/org/expeditee/encryption/items/surrogates/EncryptionDetail.java	(revision 1415)
@@ -1,21 +1,11 @@
 package org.expeditee.encryption.items.surrogates;
 
-public enum EncryptionDetail {
-	// If the property needs to be unencrypted due to inheritance then do not try to encrypt it.
-	UnencryptedOnSave,
-	
-	// If the property is not inherited by any surrogates then we can try to encrypt it.  
-	// If we do not have key then default to UnencryptedOnSave.
-	ReencryptOnSave,
-	
-	// If the property is no longer inherited by at least one surrogate then this value is present.  
-	// If it turns out there is no longer any surrogates who inherit the value then this value can be replaced with ReencryptOnSave.
-	// Otherwise, this value must be replaced with UnencryptedOnSave.
-	InheritanceCheckOnSave,
-	
-	// If we could not decrypt the value on load then EncryptionDetail.getUndecipheredValue() can be used to get the value for saving.
-	UseUndecipheredValueOnSave;
-	
-	private String undecipheredValue = null;
+public class EncryptionDetail {
+	private Type type;
+	private String undecipheredValue;
+
+	public EncryptionDetail(Type type) {
+		this.type = type;		
+	}
 	
 	public EncryptionDetail setUndecipheredValue(String undecipheredValue) {
@@ -25,5 +15,33 @@
 	
 	public String getUndecipheredValue() {
-		return this.undecipheredValue;
+		return undecipheredValue;
+	}
+	
+	public Type getEncryptionDetailType() {
+		return type;
+	}
+	
+	@Override
+	public EncryptionDetail clone() {
+		EncryptionDetail copy = new EncryptionDetail(this.type);
+		copy.setUndecipheredValue(this.undecipheredValue);
+		return copy;
+	}
+	
+	public enum Type {
+		// If the property needs to be unencrypted due to inheritance then do not try to encrypt it.
+		UnencryptedOnSave,
+		
+		// If the property is not inherited by any surrogates then we can try to encrypt it.  
+		// If we do not have key then default to UnencryptedOnSave.
+		ReencryptOnSave,
+		
+		// If the property is no longer inherited by at least one surrogate then this value is present.  
+		// If it turns out there is no longer any surrogates who inherit the value then this value can be replaced with ReencryptOnSave.
+		// Otherwise, this value must be replaced with UnencryptedOnSave.
+		InheritanceCheckOnSave,
+		
+		// If we could not decrypt the value on load then EncryptionDetail.getUndecipheredValue() can be used to get the value for saving.
+		UseUndecipheredValueOnSave;
 	}
 }
Index: trunk/src/org/expeditee/encryption/items/surrogates/Label.java
===================================================================
--- trunk/src/org/expeditee/encryption/items/surrogates/Label.java	(revision 1414)
+++ trunk/src/org/expeditee/encryption/items/surrogates/Label.java	(revision 1415)
@@ -2,107 +2,185 @@
 
 import java.util.ArrayList;
+import java.util.Arrays;
 import java.util.Base64;
-import java.util.Collection;
 import java.util.List;
-import java.util.Set;
+import java.util.function.Predicate;
 import java.util.stream.Collectors;
-
-import org.expeditee.auth.AuthenticatorBrowser;
-import org.expeditee.gui.DisplayController;
-import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameIO;
-import org.expeditee.gui.MessageBay;
+import java.util.stream.Stream;
+
+import org.expeditee.gui.ItemsList;
 import org.expeditee.items.Item;
 import org.expeditee.items.Text;
-import org.expeditee.settings.UserSettings;
+import org.expeditee.settings.identity.secrets.KeyList;
 
 public class Label {
 	
-	private static List<LabelResult> labelCache = new ArrayList<LabelResult>();
-	private static List<String> forbiddenLabels = new ArrayList<String>();
-	
-	public static LabelResult resolveKey(String label) {
-		
-		if (forbiddenLabels.contains(label)) {
+	private static int surrogateStep = -1;
+
+	public static LabelResult getLabel(String label) {
+		Text[] userLabels = KeyList.UserLabels.get();
+		Text labelText = null;
+		for (Text userLabel : userLabels) {
+			if (userLabel.getText().equals(label)) {
+				labelText = userLabel;
+				break;
+			}
+		}
+
+		if (labelText == null) {
+			return unableToFindLabelResult(label);
+		} else {
+			List<String> data = labelText.getData();
+			if (data == null || data.isEmpty()) { 
+				return unableToFindLabelResult(label);
+			}
+			String dataEntry = data.get(0);
+			
+			if (dataEntry.contains("{")) {
+				return partialKeyResult(label, dataEntry);
+			} else {
+				return fullKeyResult(label, dataEntry);
+			}
+		}
+	}
+	
+	public static void progressSurrogateMode() {
+		surrogateStep += 1;
+	}
+
+	public static void resetSurrogateMode() {
+		surrogateStep = -1;
+	}
+
+	public static List<String> getAccessibleLabelsNames(ItemsList itemsList) {
+		Text[] userLabels = KeyList.UserLabels.get();
+		Stream<String> accessibleUserWideLabels = Arrays.asList(userLabels).stream().map(label -> label.getText());
+		
+		Predicate<Item> isLabelWithoutEncryptionLabel = item -> item.getEncryptionLabel() == null || item.getEncryptionLabel().isEmpty();
+		itemsList.removeIf(isLabelWithoutEncryptionLabel);
+		Stream<String> accessibleFrameLocalLabels = itemsList.underlying().stream().map(item -> item.getEncryptionLabel()).distinct();
+		
+		List<String> accessibleLabelsUnion = accessibleUserWideLabels.collect(Collectors.toList());
+		accessibleLabelsUnion.retainAll(accessibleFrameLocalLabels.collect(Collectors.toList()));
+		
+		if (surrogateStep > -1 && surrogateStep < accessibleLabelsUnion.size()) {
+			String surrogateModeFilter = accessibleLabelsUnion.get(surrogateStep);
+			List<String> single = new ArrayList<String>();
+			single.add(surrogateModeFilter);
+			return single;
+		} else {
+			resetSurrogateMode();
+		}
+		
+		return accessibleLabelsUnion;
+	}
+
+	private static LabelResult partialKeyResult(String label, String dataEntry) {
+		dataEntry = dataEntry.substring(dataEntry.indexOf('}') + 1).trim();
+		LabelResult res = LabelResult.SuccessResolveLabelToPartialKey;
+		res.name = label;
+		return res;
+	}
+
+	private static LabelResult unableToFindLabelResult(String label) {
+		LabelResult res = LabelResult.ErrorUnableToFindLabel;
+		res.name = label;
+		return res;
+	}
+	
+	private static LabelResult fullKeyResult(String label, String dataEntry) {
+		try {
+			LabelResult res = LabelResult.SuccessResolveLabelToKey;
+			res.key = Base64.getDecoder().decode(dataEntry);
+			res.name = label;
+			return res;
+		} catch (IllegalArgumentException e) {
 			return LabelResult.ErrorUnableToFindLabel;
 		}
-		
-		LabelResult fromCache = getFromCache(label);
-		if (fromCache != null) {
-			return fromCache;
-		}
-
-		
-		String credentialsFrameName = UserSettings.ProfileName.get() + 
-				AuthenticatorBrowser.CREDENTIALS_FRAME;
-		Frame credentialsFrame = FrameIO.LoadFrame(credentialsFrameName);
-		Collection<Text> textItems = credentialsFrame.getTextItems();
-		textItems.removeIf(t -> !t.getText().equals("Secrets"));
-		textItems.removeIf(t -> !t.hasLink());
-		if (textItems.isEmpty()) {
-			return LabelResult.ErrorUnableToFindSecretsFrame;
-		}
-		Text linkToSecretsFrame = textItems.iterator().next();
-		if (!linkToSecretsFrame.hasLink()) {
-			return LabelResult.ErrorUnableToFindSecretsFrame;
-		}
-		Frame secretsFrame = FrameIO.LoadFrame(linkToSecretsFrame.getParent().getFramesetName() + linkToSecretsFrame.getLink());
-		Collection<Text> labels = secretsFrame.getTextItems();
-		labels.removeIf(lbl -> !lbl.getText().equals(label));
-		labels.removeIf(lbl -> lbl.getData() == null || lbl.getData().size() == 0);
-		if (labels.isEmpty()) {
-			return LabelResult.ErrorUnableToFindLabel;
-		}
-		Text labelItem = labels.iterator().next();
-		String data = labelItem.getData().get(0);
-		if (data.contains("{")) {
-			data = data.substring(data.indexOf('}') + 1).trim();
-			LabelResult res = LabelResult.SuccessResolveLabelToPartialKey;
-			res.key = Base64.getDecoder().decode(data);
-			return res;
-		} else {
-			try {
-				LabelResult res = LabelResult.SuccessResolveLabelToKey;
-				res.key = Base64.getDecoder().decode(data);
-				res.name = label;
-				labelCache.add(res);
-				return res;
-			} catch (IllegalArgumentException e) {
-				return LabelResult.ErrorUnableToFindLabel;
-			}
-		}
-	}
-	
-	public static void progressSurrogateMode() {
-		Collection<Item> allItems = DisplayController.getCurrentFrame().getAllItems();
-		allItems.removeIf(item -> item.getEncryptionLabel() == null);
-		MessageBay.displayMessage("Encryption labels found on items on current frame: ");
-		Set<String> allLabels = allItems.stream().map(i -> i.getEncryptionLabel()).collect(Collectors.toSet());
-		StringBuilder sb = new StringBuilder();
-		for (String label: allLabels) {
-			sb.append(label + ",");
-		}
-		MessageBay.displayMessage(sb.deleteCharAt(sb.length() - 1).toString());
-	}
-	
-	public static void resetSurrogateMode() {
-		// TODO Auto-generated method stub
-		
-	}
-	
-	private static LabelResult getFromCache(String label) {
-		List<LabelResult> cacheCanditates = labelCache.stream().filter(labelResult -> labelResult.name.equals(label)).collect(Collectors.toList());
-		if (!cacheCanditates.isEmpty()) {
-			return cacheCanditates.get(0);
-		} else {
-			return null;
-		}
-	}
-	
-//	private static List<List<String>> permutation(List<String> strings, List<List<String>> acc) {
-//		for (int i = 0; i < strings.size(); i++) {
-//			
+	}
+
+	//private static Map<LabelResult, LabelAccess> labelCache = new LinkedHashMap<LabelResult, LabelAccess>();
+	//private static int surrogateStep = -1;
+	//private static final Predicate<? super LabelResult> isAccessible = a -> labelCache.get(a).allowed;
+	
+//	public static LabelResult resolveKey(String label) {
+//		Stream<LabelResult> stream = labelCache.keySet().stream();
+//		stream = stream.filter(res -> res.name.equals(label));
+//		if (stream.count() == 0) {
+//			return resolveKeyWorker(label);
+//		} else {
+//			LabelResult labelResult = stream.collect(Collectors.toList()).get(0);
+//			LabelAccess accessible = labelCache.get(labelResult);
+//			if (accessible.allowed) { return labelResult; }
+//			else { return LabelResult.ErrorForbiddenLabel; }
+//		}
+//	}	
+//	private static LabelResult resolveKeyWorker(String label) {
+//		Frame secretsFrame = getSecretsFrame();
+//		if (secretsFrame == null) { 
+//			return LabelResult.ErrorUnableToFindSecretsFrame;
+//		}
+//		
+//		String data = getDataFromLabel(secretsFrame, label);
+//		if (data == null) {
+//			return LabelResult.ErrorUnableToFindLabel;
+//		}
+//		
+//		if (data.contains("{")) {
+//			data = data.substring(data.indexOf('}') + 1).trim();
+//			LabelResult res = LabelResult.SuccessResolveLabelToPartialKey;
+//			res.key = Base64.getDecoder().decode(data);
+//			return res;
+//		} else {
+//			try {
+//				LabelResult res = LabelResult.SuccessResolveLabelToKey;
+//				res.key = Base64.getDecoder().decode(data);
+//				res.name = label;
+//				labelCache.put(res, new LabelAccess(true));
+//				return res;
+//			} catch (IllegalArgumentException e) {
+//				return LabelResult.ErrorUnableToFindLabel;
+//			}
 //		}
 //	}
+//	
+//	private static String getDataFromLabel(Frame frame, String label) {
+//		Collection<Text> labels = frame.getTextItems();
+//		labels.removeIf(lbl -> !lbl.getText().equals(label));
+//		labels.removeIf(lbl -> lbl.getData() == null || lbl.getData().size() == 0);
+//		if (labels.isEmpty()) { return null; }
+//		Text labelItem = labels.iterator().next();
+//		List<String> data = labelItem.getData();
+//		if (data.isEmpty()) { return null; }
+//		return data.get(0);
+//	}
+//	
+//	private static Frame getSecretsFrame() {
+//		String credentialsFrameName = UserSettings.ProfileName.get() + 
+//				AuthenticatorBrowser.CREDENTIALS_FRAME;
+//		Frame credentialsFrame = FrameIO.LoadFrame(credentialsFrameName);
+//		Collection<Text> textItems = credentialsFrame.getTextItems();
+//		textItems.removeIf(t -> !t.getText().equals("Secrets"));
+//		textItems.removeIf(t -> !t.hasLink());
+//		if (textItems.isEmpty()) {
+//			return null;
+//		}
+//		Text linkToSecretsFrame = textItems.iterator().next();
+//		if (!linkToSecretsFrame.hasLink()) {
+//			return null;
+//		}
+//		Frame secretsFrame = FrameIO.LoadFrame(linkToSecretsFrame.getParent().getFramesetName() + linkToSecretsFrame.getLink());
+//		return secretsFrame;
+//	}
+//	
+//	private static class LabelAccess {
+//		public final boolean allowedDefault;
+//		public boolean allowed;
+//		
+//		public LabelAccess(boolean value) { 
+//			allowedDefault = value;
+//			allowed = allowedDefault;
+//		}
+//	} 
 	
 	public enum LabelResult {
@@ -110,5 +188,6 @@
 		SuccessResolveLabelToPartialKey, 
 		ErrorUnableToFindSecretsFrame, 
-		ErrorUnableToFindLabel;
+		ErrorUnableToFindLabel, 
+		ErrorForbiddenLabel;
 		
 		public byte[] key;
@@ -125,5 +204,7 @@
 				return "Unable to find your Secrets Frame.";
 			case ErrorUnableToFindLabel:
-				return "Unable to resolve label to encrypt/decrypt frame.  Label: ";
+				return "Unable to resolve label to encrypt/decrypt frame.  Label: " + name;
+			case ErrorForbiddenLabel:
+				return "Whilst you have the key for label " + name + " ; you are not allowed to use it.";
 			}
 			
Index: trunk/src/org/expeditee/gio/InputManager.java
===================================================================
--- trunk/src/org/expeditee/gio/InputManager.java	(revision 1414)
+++ trunk/src/org/expeditee/gio/InputManager.java	(revision 1415)
@@ -306,4 +306,11 @@
 	protected final void distributeInputEvent(InputEvent event)
 	{
+//		if (event instanceof KBMInputEvent) {
+//			KBMInputEvent kEvent = (KBMInputEvent) event;
+//			if (kEvent.getKeyDown() != null) {
+//				System.err.println("distributeInputEvent:::" + kEvent.toString());
+//			}
+//		}
+		
 		// Allow listeners to optionally consume input before gesture translation
 		for (InputEventListener listener : _inputEventListeners) {
Index: trunk/src/org/expeditee/gio/TextLayoutManager.java
===================================================================
--- trunk/src/org/expeditee/gio/TextLayoutManager.java	(revision 1414)
+++ trunk/src/org/expeditee/gio/TextLayoutManager.java	(revision 1415)
@@ -68,5 +68,5 @@
 	public float getLineWidth(Point p, Line[] lines)
 	{
-		float width = Float.MAX_VALUE;
+		float width = (float) Integer.MAX_VALUE;
 		for(Line l : lines) {
 			// check for lines that cross over our y
Index: trunk/src/org/expeditee/gio/gesture/ExpediteeKBMGestureTranslator.java
===================================================================
--- trunk/src/org/expeditee/gio/gesture/ExpediteeKBMGestureTranslator.java	(revision 1414)
+++ trunk/src/org/expeditee/gio/gesture/ExpediteeKBMGestureTranslator.java	(revision 1415)
@@ -7,4 +7,5 @@
 import org.expeditee.gio.EcosystemManager;
 import org.expeditee.gio.TimeoutQueue.TimeoutHandle;
+import org.expeditee.gio.gesture.Gesture.GestureType;
 import org.expeditee.gio.gesture.StandardGestureActions.StandardGestureType;
 import org.expeditee.gio.gesture.data.ChangeColourGestureData;
@@ -100,4 +101,5 @@
 					return null;
 				}
+				
 				//System.err.println("ExpediteeKBMGestureTranslator::" + details() + ": " + kbmEvent.getCharTyped());
 				// Generate a INSERT_STRING gesture
@@ -130,7 +132,7 @@
 		addTranslator(new InputEventToGestureTranslator(InputType.KBM)
 		{
-			private static final int NO_CONSTRAINT = 0;
+			//private static final int NO_CONSTRAINT = 0;
 			private SelectAreaGestureData _draggedFromData = null;
-			private int _constrainedDirection = NO_CONSTRAINT;
+			//private int _constrainedDirection = NO_CONSTRAINT;
 			
 			@Override
@@ -210,5 +212,5 @@
 					newMousePos.add(1, 1);
 				} else*/ {
-					_constrainedDirection = NO_CONSTRAINT;
+					//_constrainedDirection = NO_CONSTRAINT;
 					newMousePos = kbmEvent.getMouseMove().getSecondEnd().clone();
 				}
@@ -682,26 +684,40 @@
 		
 		// Add the F10 -> TOGGLE_XRAY_MODE gesture recogniser
-		addTranslator(new InputEventToGestureTranslator(InputType.KBM)
-		{
+		addTranslator(new InputEventToGestureTranslator(InputType.KBM) {
+			
 			@Override
 			public String details() { return "F10 -> TOGGLE_XRAY_MODE"; }
-
-			@Override
-			public List<Gesture> onInputEvent(InputEvent event) {
-				// Cast to keyboard/mouse event
-				KBMInputEvent kbmEvent = (KBMInputEvent) event;
-
+			
+			@Override
+			public List<Gesture> onInputEvent(InputEvent event) {
+				// Cast to keyboard/mouse event
+				KBMInputEvent kbmEvent = (KBMInputEvent) event;
+				
 				// Must be pressing F10 to xray mode
-				if (kbmEvent.getKeyDown() != KBMInputEvent.Key.F10) {
-					return null;
-				}
-				
-				// Return the gesture
-				if (kbmTranslator.isKeyDown(Key.SHIFT)) {
-					UndoGestureData data = new UndoGestureData(kbmTranslator.isKeyDown(Key.CTRL));
-					return Gesture.single(StandardGestureActions.getInstance().gestureType(StandardGestureType.TOGGLE_SURROGATE_MODE), data);
-				} else {
-					return Gesture.single(StandardGestureActions.getInstance().gestureType(StandardGestureType.TOGGLE_XRAY_MODE), null);
-				}
+				if (kbmEvent.getKeyDown() != KBMInputEvent.Key.F10 || kbmTranslator.isKeyDown(Key.SHIFT)) {
+					return null;
+				}
+				
+				return Gesture.single(StandardGestureActions.getInstance().gestureType(StandardGestureType.TOGGLE_XRAY_MODE), null);
+			}
+		});
+		
+		// Add the F10 -> CYCLE_SURROGATE_MODE gesture recogniser
+		addTranslator(new InputEventToGestureTranslator(InputType.KBM) { 
+			@Override
+			public String details() { return "F10 -> CYCLE_SURROGATE_MODE"; }
+			
+			@Override
+			public List<Gesture> onInputEvent(InputEvent event) {
+				// Case to keyboard/mouse event
+				KBMInputEvent kbmEvent = (KBMInputEvent) event;
+				
+				// Must be pressing F10 to surrogate mode
+				if (kbmEvent.getKeyDown() != KBMInputEvent.Key.F10 || !kbmTranslator.isKeyDown(Key.SHIFT)) {
+					return null;
+				}
+				
+				UndoGestureData data = new UndoGestureData(kbmTranslator.isKeyDown(Key.CTRL));
+				return Gesture.single(StandardGestureActions.getInstance().gestureType(StandardGestureType.CYCLE_SURROGATE_MODE), data);
 			}
 		});
@@ -2190,4 +2206,25 @@
 					return Gesture.single(vFormat);
 				}
+			}
+		});
+		
+		// Add the ENTER_CHAR_TYPED -> ACTIVATE BUTTON -> FORMAT gesture recogniser
+		addTranslator(new InputEventToGestureTranslator(InputType.KBM)
+		{
+			@Override
+			public String details() { return "ENTER_CHAR_TYPED -> ACTIVATE BUTTON"; }
+
+			@Override
+			public List<Gesture> onInputEvent(InputEvent event) {
+				// Cast to keyboard/mouse event
+				KBMInputEvent kbmEvent = (KBMInputEvent) event;
+			
+				if (kbmEvent.getKeyDown() != Key.ENTER) {
+					return null;
+				}
+				
+				GestureType gestureType = StandardGestureActions.getInstance().gestureType(StandardGestureType.ACTIVATE_BUTTON);
+				ItemSpecificGestureData data = new ClickGestureData(false);
+				return Gesture.single(gestureType, data);
 			}
 		});
Index: trunk/src/org/expeditee/gio/gesture/StandardGestureActions.java
===================================================================
--- trunk/src/org/expeditee/gio/gesture/StandardGestureActions.java	(revision 1414)
+++ trunk/src/org/expeditee/gio/gesture/StandardGestureActions.java	(revision 1415)
@@ -54,4 +54,5 @@
 import org.expeditee.gui.FreeItems;
 import org.expeditee.gui.MessageBay;
+import org.expeditee.gui.ItemsList;
 import org.expeditee.gui.Vector;
 import org.expeditee.io.ExpClipReader;
@@ -123,7 +124,8 @@
 		TOGGLE_ITEMS_MARK, // Show/hide the little circle indicating the item has a link and/or action
 		TOGGLE_XRAY_MODE, // F10
-		TOGGLE_SURROGATE_MODE, // Shift + F10
+		CYCLE_SURROGATE_MODE, // Shift + F10
 		UNDO, 
-		ZOOM
+		ZOOM, 
+		ACTIVATE_BUTTON // Enter while over Item with _acceptsKeyboardEnter set to true
 	}
 	//@formatter:on
@@ -420,5 +422,18 @@
 			public void exec(Gesture gesture) {
 				InsertStringGestureData data = (InsertStringGestureData) gesture.getData();
-				for (char c : data.getString().toCharArray()) {
+				
+				Item currentItem = data.getCurrentItem();
+				char[] charArray = data.getString().toCharArray();
+				
+				if (currentItem != null) {
+					// If we are over a item taht accepts keyboard enter and the only 
+					// character being entered is the enter key then we do not insert it.
+					boolean keyboardEnter = data.getCurrentItem().acceptsKeyboardEnter();
+					if (keyboardEnter && charArray.length == 1 && charArray[0] == (char) 10) {
+						return;
+					}
+				}
+								
+				for (char c : charArray) {
 					processChar(c, data.isShiftDown());
 				}
@@ -967,5 +982,16 @@
 		});
 		
-		setGestureAction(gestureType(StandardGestureType.TOGGLE_SURROGATE_MODE), new GestureAction() {
+		// Set the ACTIVATE BUTTON action
+		setGestureAction(gestureType(StandardGestureType.ACTIVATE_BUTTON), new GestureAction() {
+			@Override
+			public void exec(Gesture gesture) {
+				ItemSpecificGestureData data = (ItemSpecificGestureData) gesture.getData();
+				if (data.getCurrentItem().acceptsKeyboardEnter()) {
+					getGestureAction(Gesture.GestureType.get("CLICK")).exec(gesture);
+				}
+			}			
+		});
+		
+		setGestureAction(gestureType(StandardGestureType.CYCLE_SURROGATE_MODE), new GestureAction() {
 			@Override
 			public void exec(Gesture gesture) {
@@ -1745,5 +1771,5 @@
 			if (_lastHoldsHighlight) {
 				_lastHoldsHighlight = false;
-				for (Item i : DisplayController.getCurrentFrame().getItems()) {
+				for (Item i : DisplayController.getCurrentFrame().getSortedItems()) {
 					if (i.isHighlighted() && i != on) {
 						FrameGraphics.changeHighlightMode(i, Item.HighlightMode.None);
@@ -1824,5 +1850,5 @@
 
 		if (checkEnclosure) {
-			ItemUtils.EnclosedCheck(toAnchor.getParentOrCurrentFrame().getItems());
+			ItemUtils.EnclosedCheck(toAnchor.getParentOrCurrentFrame().getSortedItems());
 			DisplayController.requestRefresh(true);
 		}
@@ -1936,6 +1962,5 @@
 				}
 			} else if (!toUndo.contains(i)) {
-				if (addToUndo)
-				 {
+				if (addToUndo) {
 					toUndo.add(i); // Why was is this a copy
 				}
@@ -1951,5 +1976,5 @@
 		// the current frame as well as the overlay frame
 		Frame currentFrame = DisplayController.getCurrentFrame();
-		currentFrame.addToUndoDelete(itemList);
+		currentFrame.addToUndoDelete(new ItemsList(itemList));
 		itemList.clear();
 		if (bReparse) {
@@ -3268,5 +3293,5 @@
 			SessionStats.DeletedItems(toUndo);
 			if (parent != null) {
-				parent.addToUndoDelete(toUndo);
+				parent.addToUndoDelete(new ItemsList(toUndo));
 				parent.removeAllItems(toUndo); // toDelete.getConnected()
 			}
@@ -3610,5 +3635,5 @@
 							DisplayController.setCursorPosition(toDisconnect.getPosition(), false);
 							pickup(newPoint);
-							ItemUtils.EnclosedCheck(toDisconnect.getParentOrCurrentFrame().getItems());
+							ItemUtils.EnclosedCheck(toDisconnect.getParentOrCurrentFrame().getSortedItems());
 						}
 					}
@@ -3926,5 +3951,5 @@
 		mergee.getParent().setChanged(true);
 
-		ItemUtils.EnclosedCheck(mergee.getParent().getItems());
+		ItemUtils.EnclosedCheck(mergee.getParent().getSortedItems());
 		// Mike: Why does parse frame have to be called?!?
 		FrameUtils.Parse(mergee.getParent());
@@ -4386,5 +4411,5 @@
 			int mouseY = position.getY();
 			// System.out.println(mouseX + "," + mouseY);
-			for (Item i : DisplayController.getCurrentFrame().getItems()) {
+			for (Item i : DisplayController.getCurrentFrame().getSortedItems()) {
 				// System.out.println(i.getName().toString());
 				if (i instanceof Text) {
Index: trunk/src/org/expeditee/gio/input/InputEventToGestureTranslatorSet.java
===================================================================
--- trunk/src/org/expeditee/gio/input/InputEventToGestureTranslatorSet.java	(revision 1414)
+++ trunk/src/org/expeditee/gio/input/InputEventToGestureTranslatorSet.java	(revision 1415)
@@ -57,4 +57,11 @@
 		if (_recognisers.isEmpty())
 			return null;
+		
+//		if (event instanceof KBMInputEvent) {
+//			KBMInputEvent kEvent = (KBMInputEvent) event;
+//			if (kEvent.getKeyDown() != null) {
+//				System.err.println("onInputEvent:::" + kEvent.toString());
+//			}
+//		}
 
 		// Only interested in monitored events
Index: trunk/src/org/expeditee/gio/input/KBMInputEvent.java
===================================================================
--- trunk/src/org/expeditee/gio/input/KBMInputEvent.java	(revision 1414)
+++ trunk/src/org/expeditee/gio/input/KBMInputEvent.java	(revision 1415)
@@ -37,4 +37,5 @@
 		BACKSPACE,
 		TAB,
+		ENTER,
 		A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z
 	}
Index: trunk/src/org/expeditee/gio/input/StandardInputEventListeners.java
===================================================================
--- trunk/src/org/expeditee/gio/input/StandardInputEventListeners.java	(revision 1414)
+++ trunk/src/org/expeditee/gio/input/StandardInputEventListeners.java	(revision 1415)
@@ -52,6 +52,5 @@
 		
 		@Override
-		public boolean onInputEvent(InputEvent event)
-		{
+		public boolean onInputEvent(InputEvent event) {
 			// Only interested in keyboard/mouse events
 			if (event.getInputType() != InputType.KBM) return false;
@@ -77,16 +76,13 @@
 		}
 		
-		public boolean isKeyDown(Key key)
-		{
+		public boolean isKeyDown(Key key) {
 			return (key != null) && (_keyState[key.ordinal()] == Boolean.TRUE);
 		}
 		
-		public boolean isMouseButtonDown(MouseButton button)
-		{
+		public boolean isMouseButtonDown(MouseButton button) {
 			return (button != null) && (_mouseState[button.ordinal()] == Boolean.TRUE);
 		}
 		
-		public boolean isOnlyMouseButtonDown(MouseButton button)
-		{
+		public boolean isOnlyMouseButtonDown(MouseButton button) {
 			if (button == null) return false;
 			
@@ -98,6 +94,5 @@
 		}
 		
-		public boolean isAnyMouseButtonDown()
-		{
+		public boolean isAnyMouseButtonDown() {
 			for (MouseButton button : MouseButton.values()) {
 				if (isMouseButtonDown(button)) return true;
Index: trunk/src/org/expeditee/gio/javafx/JavaFXConversions.java
===================================================================
--- trunk/src/org/expeditee/gio/javafx/JavaFXConversions.java	(revision 1414)
+++ trunk/src/org/expeditee/gio/javafx/JavaFXConversions.java	(revision 1415)
@@ -137,4 +137,5 @@
 		case Y: return org.expeditee.gio.input.KBMInputEvent.Key.Y;
 		case Z: return org.expeditee.gio.input.KBMInputEvent.Key.Z;
+		case ENTER: return org.expeditee.gio.input.KBMInputEvent.Key.ENTER;
 		default: return null;
 		}
Index: trunk/src/org/expeditee/gio/swing/SwingConversions.java
===================================================================
--- trunk/src/org/expeditee/gio/swing/SwingConversions.java	(revision 1414)
+++ trunk/src/org/expeditee/gio/swing/SwingConversions.java	(revision 1415)
@@ -350,4 +350,5 @@
 		case java.awt.event.KeyEvent.VK_Y: return org.expeditee.gio.input.KBMInputEvent.Key.Y;
 		case java.awt.event.KeyEvent.VK_Z: return org.expeditee.gio.input.KBMInputEvent.Key.Z;
+		case java.awt.event.KeyEvent.VK_ENTER: return org.expeditee.gio.input.KBMInputEvent.Key.ENTER;
 		default: return null;
 		}
